"use strict";
this.name = "vector";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Mission. Funny things in 'Richman's World'";
this.version = "1.7.1";

this.startUp = function()
{
	delete this.startUp;
	if(worldScripts.vector_pad.startUp) worldScripts.vector_pad.startUp();
	this.logging = false;
	this.audio = true;
	this.extraA = false;
	this.extraB = true;
	this.excludedScreens = ['GUI_SCREEN_OPTIONS','GUI_SCREEN_SAVE','GUI_SCREEN_LOAD','GUI_SCREEN_INTRO1','GUI_SCREEN_INTRO2','GUI_SCREEN_MISSION','GUI_SCREEN_REPORT'];
	this.mySound = new SoundSource;
	this.mySound.loop = true;
	this.hasShown = false;
	this.slaunch = false;
	if(!this.andale) this.andale = false;
	this.ISSOrNova = false;
	this.allowS = false;
	this.allowI = false;
	this.tempRisk = 0;
	this.addChance = 1;
	this.red = 0;
	this.dataRW(1);
}
this.dataRW = function(mode)
{
	if(mode){
		if(!worldScripts.vector_pad.deactivated) this.inf = worldScripts.vector_pad.padInfos.generic;
		else this.inf ={cpod:[],cpods:0,epod:[],epods:0,expFactor:1,passengerState:0,superman:0}
		if(missionVariables.vector_cpod){
			this.inf.cpod = missionVariables.vector_cpod.split('|');
			this.inf.cpods = this.inf.cpod.length;
		}
		if(missionVariables.vector_epod){
			this.inf.epod = missionVariables.vector_epod.split('|');
			this.inf.epods = this.inf.epod.length;
		}
		if(player.score>249) missionVariables.vector_limiter = null;
		missionVariables.vector_passengerState = null;
		missionVariables.vector_cpod = null;
		missionVariables.vector_cpods = null;
		missionVariables.vector_epod = null;
		missionVariables.vector_epods = null;
	} else {
		this.inf.passengerState = 0;
		this.inf.cpod = [];
		this.inf.cpods = 0;
		this.inf.epod = [];
		this.inf.epods = 0;
		this.inf.pasState = 0;
		if(!worldScripts.vector_pad.deactivated){
			this.inf.superman = worldScripts.vector_pad.padInfos.generic.superman;
			worldScripts.vector_pad.padInfos.generic = this.inf;
		}
	}
	return;
}
this.shipWillDockWithStation = function(station)
{
	if(!player.ship.docked) return;
	this.dataRW(1);
	if(this.ISSOrNova){
		this.allowS = false;
		this.allowI = false;
		this.tempRisk = 0;
	} else this.setStationFlags(station);
}
this.setStationFlags = function(curstat)
{ /* Station, Risk, Screen, GalCop */
	var sList = ["Astromine Penal Colony",1.3,true,true,"Augeaian Orbital Repair Facility",0.8,true,true,"Black Monk Monastery",0.8,true,false,
		"CoachWhip hOopy Casino",1.8,true,true,"Collective SLAPU Imperial AstroFactory",1.3,true,true,"Collective ZGF",0.7,true,false,
		"Deep Space Hoopy Hotel : Hades Branch",1.1,true,true,"Deep Space Hoopy Hotel : Lernean Branch",1.1,true,true,
		"Free Trade Zone",0.8,true,false,"Griff Research Ltd Orbital Base",1.2,true,true,"GRS Buoy Factory",1.5,true,true,"Hacker Outpost",0.8,true,false,
		"Hesperides Wiseguy Way-Station",1.1,true,true,"Imperial AstroFactory",1.7,true,true,"Liberty Station",1.8,true,true,"Navy SecCom Station",1.8,true,true,
		"Pirate Base",1.8,true,false,"Pirate Rock",1.7,true,false,"Rebel Outpost",1.8,true,false,"Renegade Phoenix",1.8,true,true,"Renegade Station",1.6,true,true,
		"Rock Hermit",1.2,true,true,"Royal Court",1.7,false,false,"Royal Hunting Lodge",1.7,false,false,"Salvage Gang",1.2,true,false,"Sentinel Station",1.4,true,true,
		"Special Branch Orbital Headquaters",1.8,true,true,"Special Interstellar Repairs and Shipyard Facility",1.6,true,true,"Sun Research Station Alpha",1.5,true,true,
		"Sun Research Station Beta",1.5,true,true,"Sun Research Station Delta",1.5,true,true,"Sun Research Station Omega",1.5,true,true,"Super Hub",1.4,true,true,
		"Taranis Corporation HQ",1.8,true,true,"The Link Base",1.9,true,false,"TransHab Station",1.4,true,true];
	let e = sList.indexOf(curstat.name);
	if(e!==-1){
		if(!curstat.bounty){this.allowS = sList[e+2]; this.allowI = sList[e+3]; this.tempRisk = sList[e+1];}
		else {this.allowS = sList[e+2]; this.allowI = false; this.tempRisk = sList[e+1];}
	} else {
		if(curstat.isMainStation && !curstat.bounty){this.allowS = true; this.allowI = true; this.tempRisk = 1.5;}
		else {
			if(curstat.AI==="randomhitsbarAI.plist"){this.allowS = true; this.allowI = true; this.tempRisk = 1.3;}
			else if(curstat.primaryRole==="constore"){this.allowS = true; this.allowI = true; this.tempRisk = 1.6;}
			else {this.allowS = false; this.allowI = false; this.tempRisk = 0;}
		}
	}
	if(this.logging) log(this.name,this.name+': Stationkey: ISS:'+this.ISSOrNova+' S:'+this.allowS+' I:'+this.allowI+' R:'+this.tempRisk);
	return;
}
this.shipDockedWithStation = function()
{
	this.mySound.stop();
	this.hasShown = false;
	if(!player.ship.docked || this.ISSOrNova || !this.allowS) return;
	if(!this.inf.cpods && !this.inf.epods && this.excludedScreens.indexOf(guiScreen)===-1){
		if(this.inf.expFactor>20 && Math.random()<(0.01*Math.log(this.inf.expFactor))){
			this.showScreen(2,null,null,null);
			this.revenge = Math.ceil(Math.log(this.inf.expFactor*500)*0.25);
		} else if(this.andale && system.government>5 && !(clock.days&3) && Math.random()>0.8){this.dataRW(1); this.showScreen(6,null,null,5);}
		this.hasShown = true;
		return;
	}
}
this.missionScreenOpportunity = function()
{
	if(this.ISSOrNova || !player.ship.docked || !this.allowS || this.hasShown || (!this.inf.cpods && !this.inf.epods)) return;
	if(!this.mc){
		this.dataRW(1);
		this.mc = new Object({screen:0,react:0,sumToOffer:0,sumCargo:0,sumPods:0,sTotal:0,loop:0,advice:'',EName:'',ETyp:'',CName:'',CTyp:''});
		this.mc.expLog = Math.log(this.inf.expFactor*5);
		this.mc.rp = this.mc.expLog*0.1;
		this.mc.hint = Math.floor(Math.log((1+system.government)*this.mc.expLog)*1.7);
		if(this.inf.cpod.length) ++this.mc.screen;
		if(this.inf.epod.length) ++this.mc.screen;
	}
	this.missionOffers();
}
this.missionOffers = function()
{
	if(this.inf.epod.length) this.mc.loop = 1;
	else if(this.inf.cpod.length) this.mc.loop = 2;
	switch(this.mc.loop){
		case 1: this.showEPods(); this.mc.loop = 4; break;
		case 2: this.showCPods(); this.mc.loop = 4; break;
		default: this.hasShown = true;}
	return;
}
this.showEPods = function()
{
	var lineAdd = 8-this.inf.epod.length;
	if(this.inf.epod.length===1){
		if(this.inf.expFactor<40) this.showScreen(1,'VECTOR_OFFERA',null,null);
		else this.showScreen(1,'VECTOR_OFFERC',null,null);
	} else {
		if(this.inf.expFactor<40) this.showScreen(1,'VECTOR_OFFERB',null,null);
		else this.showScreen(1,'VECTOR_OFFERD',null,null);
	}
	var i = this.inf.epod.length;
	while(i--){
		this.calculateSum(this.inf.epod[i],1);
		mission.addMessageText("Esc-Pod:\r\r"+this.mc.EName+" "+this.mc.ETyp+".");
	}
	mission.addMessageTextKey("VECTOR_LINE");
	this.mc.sumPods = Math.ceil(this.mc.sumToOffer);
	if(this.mc.sumPods<400) this.mc.sumPods = 400;
	if(this.inf.expFactor>=40){
		lineAdd--;
		mission.addMessageText("\r\r\r\r\r\r\r\rPossible ransom: "+this.mc.sumPods+" Credits.");
	}
	i = lineAdd;
	while(i--) mission.addMessageText("");
	let friends = ["low","acceptable","average","medium","high","dangerous","extreme"];
	if(this.inf.expFactor>20) mission.addMessageText("Friends gave you a hint that the risk for transactions is currently "+friends[this.mc.hint]+".");
	mission.addMessageTextKey("VECTOR_QUESTION");
	this.mc.sumToOffer = 0;
	return;
}
this.showCPods = function()
{
	var lineAdd = 8-this.inf.cpod.length;
	if(this.inf.expFactor<30) this.showScreen(1,'VECTOR_OFFERE',null,null);
	else this.showScreen(1,'VECTOR_OFFERF',null,null);
	var i = this.inf.cpod.length;
	while(i--){
		this.calculateSum(this.inf.cpod[i],2);
		mission.addMessageText("Cargo:\r\r"+this.mc.CName+" "+this.mc.CTyp+".");
	}
	mission.addMessageTextKey("VECTOR_LINE");
	this.mc.sumCargo = Math.ceil(this.mc.sumToOffer);
	if(this.mc.sumCargo<300) this.mc.sumCargo = 300;
	if(this.inf.expFactor>=30){
		lineAdd--;
		mission.addMessageText("\r\r\r\r\r\r\r\rPossible deal: "+this.mc.sumCargo+" Credits.");
	}
	i = lineAdd;
	while(i--) mission.addMessageText("");
	let friends = ["low","acceptable","average","medium","high","dangerous","extreme"];
	if(this.inf.expFactor>10) mission.addMessageText("Friends gave you a hint that the risk for transactions is currently "+friends[this.mc.hint]+".");
	mission.addMessageTextKey("VECTOR_QUESTION");
	this.mc.sumToOffer = 0;
	return;
}
this.calculateSum = function(nam,typ)
{
	var factorPod = 1,currentName = nam.split(' ');
	if(!currentName[2]) currentName[2] = '(unknown)';
	if(typ===1){
		switch(currentName[2]){
			case '(Frood)': factorPod += 1.3; break;
			case '(Geek)': factorPod += 1.6; break;
			case '(Millionaire)': factorPod += 2; break;
			default: factorPod = 1.0;
		}
		this.mc.EName = currentName[0]+' '+currentName[1];
		this.mc.ETyp = currentName[2];
	} else {
		switch(currentName[2]){
			case '(Collection)': factorPod += 1.1; break;
			case '(Precious)': factorPod += 0.7; break;
			case '(Heirloom)': factorPod += 0.3; break;
			default: factorPod += 0.2;
		}
		this.mc.CName = currentName[0]+' '+currentName[1];
		this.mc.CTyp = currentName[2];
	}
	var singleSum = Math.log(system.productivity*this.inf.expFactor*(factorPod*((1+system.government)*0.5)))*(5*this.inf.expFactor)*(1+Math.random());
	if(this.red>2) singleSum /= Math.log(this.red);
	this.mc.sumToOffer += singleSum;
	return;
}
this.choiceEvaluation = function(choice)
{
	switch(choice){
		case "VECTOR_FREE": this.mc.loop = 2; this.inf.epod = []; this.mc.react += 1; this.mc.sumPods = this.mc.sumPods*0.1667;
			if(this.inf.expFactor>1) this.inf.expFactor -= 1; this.mc.screen--; if(this.inf.cpod.length) this.showCPods(); break;
		case"VECTOR_SLAVE": this.mc.loop = 2; this.inf.epod = []; this.mc.react += 2; this.mc.sumPods = this.mc.sumPods*0.25;
			if(this.inf.expFactor<100) this.inf.expFactor += 1; this.mc.screen--; if(this.inf.cpod.length) this.showCPods(); break;
		case "VECTOR_ZRANSOM": this.mc.loop = 2; this.inf.epod = []; this.mc.react += 4;
			if(this.inf.expFactor<97) this.inf.expFactor += 3; this.mc.screen--; if(this.inf.cpod.length) this.showCPods(); break;
		case "VECTOR_LEAVE": this.mc.loop = 4; this.inf.cpod = []; this.mc.react += 8; this.mc.sumCargo = this.mc.sumCargo*0.1667;
			if(this.inf.expFactor>1) this.inf.expFactor -= 1; this.mc.screen--; break;
		case "VECTOR_SELL": this.mc.loop = 4; this.inf.cpod = []; this.mc.react += 16; this.mc.sumCargo = this.mc.sumCargo*0.25;
			if(this.inf.expFactor<100) this.inf.expFactor += 1; this.mc.screen--; break;
		case "VECTOR_ZDEAL": this.mc.loop = 4; this.inf.cpod = []; this.mc.react += 32;
			if(this.inf.expFactor<98) this.inf.expFactor += 2; this.mc.screen--; break;
		default:
	}
	if(!this.inf.epod.length && !this.inf.cpod.length && !this.mc.screen && this.mc.react) this.createReaction();
	return;
}
this.createReaction = function()
{
	this.slaunch = false;
	this.mc.sumPods = Math.ceil(this.mc.sumPods);
	this.mc.sumCargo = Math.ceil(this.mc.sumCargo);
	this.mc.sTotal = this.mc.sumPods+this.mc.sumCargo;
	this.calculateRisk();
	var chance = Math.random();
	if((this.mc.react&1)) this.freeHim(chance);
	if((this.mc.react&2)) this.sellAsSlave(chance);
	if((this.mc.react&4)){this.mc.risk += 1.5; this.ransomNow(chance);}
	if((this.mc.react&8)) this.giveBack(chance);
	if((this.mc.react&16)) this.blackMarket(chance);
	if((this.mc.react&32)){this.mc.risk += 1.3; this.makeDeal(chance);}
	this.finishedAndExit();
	return;
}
this.calculateRisk = function(simple)
{
	this.mc.risk = this.tempRisk;
	if(!simple) this.mc.risk *=(Math.log((this.mc.sumPods+this.mc.sumCargo)/32)*(1+system.government)*Math.random())*(this.inf.expFactor*0.01);
	else this.mc.risk = Math.ceil(this.mc.risk/(1+(system.government*Math.random())));
	return;
}
this.calculateRed = function(mode){
	switch(mode){
		case 1: this.mc.sumPods = Math.ceil(this.mc.sumPods/Math.log(this.red)); break;
		case 3: this.mc.sTotal = Math.ceil(this.mc.sTotal*Math.log(this.red)); break;
		case 5: this.mc.sumCargo = Math.ceil(this.mc.sumCargo/Math.log(this.red)); break;
	}
	return;
}
this.freeHim = function(chance)
{
	if(this.allowI) chance *= 0.7;
	if(chance>(0.25-this.mc.rp*0.5)){
		this.mc.react &= 56;
		this.mc.sumPods = 0;
		return;
	}
	this.mc.advice = expandDescription("[vector_free]")+"\nWith this words "+this.mc.EName+" presents you\n"+this.mc.sumPods+".0 Credits for his safe return.";
	player.credits += this.mc.sumPods;
	this.showScreen(3,null,1,5);
	return;
}
this.sellAsSlave = function(chance)
{
	if(this.allowI){
		if(this.mc.risk>25 && chance>(0.90-this.mc.rp)){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*2.5))+".0 Credits\nfor slavery and added an entry to your ID.";
			this.calculatePenalty(this.mc.sTotal*2.5);
			this.mc.react = 64;
			player.ship.bounty += 3;
			this.showScreen(5,null,1,7);
			return;
		}
		if(chance>0.45 && chance<(0.50+this.mc.rp*0.5) && this.mc.risk > 4){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*2))+".0 Credits\nfor intentional slavery.";
			this.calculatePenalty(this.mc.sTotal*2);
			this.mc.react = 64;
			this.showScreen(5,null,1,7);
			return;
		}
		if(chance>0.25 && chance<0.40 && this.mc.risk>1){
			this.mc.react &= 56;
			this.mc.advice = "GalCop Police has confiscated your Pods.";
			this.mc.sumPods = 0;
			return;
		}
	} else chance -= Math.random();
	if(chance<0.15){
		this.mc.react &= 56;
		this.mc.sumPods = 0;
		this.mc.advice = "The slaver tricked you and you lost your money.";
		return;
	}
	this.mc.advice = "The slaver paid "+this.mc.sumPods+".0 Credits for your special cargo.";
	return;
}
this.ransomNow = function(chance)
{
	if(this.allowI){
		if(this.mc.risk>20 && chance>(0.90-this.mc.rp)){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*4))+".0 Credits\nfor intentional hijacking of "+this.mc.EName+"\nand added an entry to your ID.";
			this.calculatePenalty(this.mc.sTotal*4);
			this.mc.react = 64;
			player.ship.bounty += 3;
			this.showScreen(5,null,1,6);
			return;
		}
		if(chance>0.25 && chance<0.40 && this.mc.risk>1){
			this.mc.react &= 56;
			this.mc.advice = "GalCop Police has confiscated your Pods.";
			this.mc.sumPods = 0;
			return;
		}
		if(chance>0.45 && chance<(0.50+this.mc.rp*0.7) && this.mc.risk>3){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*3.2))+".0 Credits\nfor kidnapping "+this.mc.EName+".";
			this.calculatePenalty(this.mc.sTotal*3.2);
			this.mc.react = 64;
			this.showScreen(5,null,1,7);
			return;
		}
	} else chance -= Math.random();
	if(chance<0.15){
		this.mc.react &= 56;
		this.mc.sumPods = 0;
		this.mc.advice = "The family tricked you and you lost your money.";
		return;
	}
	this.mc.advice = "The family paid to you: "+this.mc.sumPods+".0 Credits.";
	return;
}
this.giveBack = function(chance)
{
	if(this.allowI) chance *= 1.1;
	if(chance<(0.55+this.mc.rp*0.5)){
		this.mc.react &= 7;
		this.mc.sumCargo = 0;
		return;
	}
	this.mc.advice = "For returning the "+this.mc.CName+"\nwe'll award you "+this.mc.sumCargo+".0 Credits.\n\nIt takes a few moments to transfer it\nto your account.";
	player.credits += this.mc.sumCargo;
	if(this.allowI) this.showScreen(4,null,1,4);
	else this.showScreen(7,null,1,4);
	return;
}
this.blackMarket = function(chance)
{
	if(this.allowI){
		if(this.mc.risk>25 && chance<(0.10+this.mc.rp)){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*2.5))+".0 Credits\nfor intentional dealing with stolen goods\nand added an entry to your ID.";
			this.calculatePenalty(this.mc.sTotal*2.5);
			this.mc.react = 64;
			player.ship.bounty += 3;
			this.showScreen(5,null,1,6);
			return;
		}
		if(chance>0.15 && chance<(0.20+this.mc.rp*0.5) && this.mc.risk>1){
			this.mc.react &= 7;
			this.mc.advice += "\nGalCop Police has confiscated your stolen goods.";
			this.mc.sumCargo = 0;
			return;
		}
		if(chance>0.45 && chance<(0.60+this.mc.rp*0.8) && this.mc.risk>4){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*2))+".0 Credits\nfor dealing with stolen goods.";
			this.calculatePenalty(this.mc.sTotal*2);
			this.mc.react = 64;
			this.showScreen(5,null,1,7);
			return;
		}
	} else chance += Math.random();
	if(chance>0.75){
		this.mc.react &= 7;
		this.mc.sumCargo = 0;
		this.mc.advice += "\nThe dealer tricked you and you lost your money.";
		return;
	}
	this.mc.advice += "\nOn the blackmarket you've got: "+this.mc.sumCargo+".0 Credits.";
	return;
}
this.makeDeal = function(chance)
{
	if(this.allowI){
		if(this.mc.risk>20 && chance<(0.10+this.mc.rp)){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*4.5))+".0 Credits\nfor attempted extortion and added an entry\nto your ID.";
			this.calculatePenalty(this.mc.sTotal*4.5);
			this.mc.react = 64;
			player.ship.bounty += 3;
			this.showScreen(5,null,1,6);
			return;
		}
		if(chance>0.15 && chance<(0.20+this.mc.rp*0.5) && this.mc.risk>1){
			this.mc.react &= 7;
			this.mc.advice += "\nGalCop Police has confiscated your stolen goods.";
			this.mc.sumCargo = 0;
			return;
		}
		if(chance>0.45 && chance<(0.50+this.mc.rp*0.8) && this.mc.risk>5){
			if(this.red>3) this.calculateRed(3);
			this.mc.advice = "GalCop Police fined you with "+(Math.ceil(this.mc.sTotal*3))+".0 Credits\nfor attempted extortion.";
			this.calculatePenalty(this.mc.sTotal*3);
			this.mc.react = 64;
			this.showScreen(5,null,1,7);
			return;
		}
	} else chance -= Math.random();
	if(chance<0.15){
		this.mc.react &= 7;
		this.mc.sumCargo = 0;
		this.mc.advice = "The assurance tricked you and you lost your money.";
		return;
	}
	this.mc.advice += "\nThe assurance paid: "+this.mc.sumCargo+".0 Credits.";
	return;
}
this.calculatePenalty = function(penalty)
{
	let p = Math.ceil(penalty);
	player.credits = Math.max(player.credits-p,30);
	if(this.mc){
		this.mc.sumPods = 0;
		this.mc.sumCargo = 0;
	}
	worldScripts.vector_pad.addToLogbook("BAD $"+p);
	return;
}
this.finishedAndExit = function()
{
	if(!(this.mc.react&64)){
		var a = this.mc.sumPods+this.mc.sumCargo;
		player.credits += a;
		if(a) worldScripts.vector_pad.addToLogbook("BAC $"+(this.mc.sumPods+this.mc.sumCargo));
		else worldScripts.vector_pad.addToLogbook("BAE "+system.name);
	}
	if(this.mc.advice){
		if(!this.adviceTimer) this.adviceTimer = new Timer(this,this.doAdviceTimer,0,3);
		else this.adviceTimer.start();
	}
	this.hasShown = true;
	this.dataRW();
	if(this.logging){
		for(let prop in this.mc) log(this.name,this.name+':'+prop+': '+this.mc[prop]);
		log(this.name,this.name+": hasShown:"+this.hasShown+" addChance:"+this.addChance+" pasState:"+this.inf.pasState+" expFactor:"+this.inf.expFactor);
		log(this.name,this.name+" mV.cpods:"+this.inf.cpods+" mV.epods:"+this.inf.epods);
	}
	return;
}
this.doAdviceTimer = function()
{
	if(this.mc && this.mc.advice!=='' && this.excludedScreens.indexOf(guiScreen)===-1){
		player.commsMessage(this.mc.advice,8);
		this.mc.advice = '';
		this.cleanAdvice();
	} else if(!player.ship.isValid) this.cleanAdvice();
}
this.shipWillLaunchFromStation = function()
{
	if(!this.myColor){
		this.myColor = [[0.4,1,0.4,1],null];
		if(worldScripts.OXPConfig) this.myColor = worldScripts.OXPConfig.genericUserColors[4];
		else if(missionVariables.genericUserColors) this.myColor = JSON.parse(missionVariables.genericUserColors)[4];
	}
	this.checkSun();
	this.cleanAdvice();
	this.red = 0;
	if(worldScripts.Cabal_Common_OXPStrength){
		var c = worldScripts.Cabal_Common_OXPStrength.checkOXPStrength.checkPower(player.ship);
		if(c>320) this.red = Math.ceil(Math.log(c-320));
		else this.red = 0;
	} else if(player.score>512) this.red = 6;
	if(this.ISSOrNova) return;
	++this.addChance;
	this.addChance &= 7;
}
this.shipLaunchedFromStation = function(station)
{
	if(this.ISSOrNova) return;
	if(this.mc){
		if(this.mc.screen){
			player.commsMessage("You've decided to reload your special cargo.");
			if(Math.random()>(0.4/this.tempRisk) && !this.revenge && this.slaunch && this.allowI) worldScripts.vector_insp.startInspection(station);
		}
		if(parseInt(this.inf.epods)>0){
			if(this.inf.passengerState==1){
				this.setSound(1);
				player.commsMessage("Your passenger is still totally drunken.");
			} else if(this.inf.passengerState==2){
				this.setSound(2);
				player.commsMessage("Your passenger is still a little bit renitent.");
			}
		}
		if(this.hasShown && this.mc.advice && this.mc.advice!=='') player.commsMessage(this.mc.advice,8);
		delete this.mc;
		this.slaunch = false;
	}
	if(this.revenge){
		system.addShips('vector_revenge1',this.revenge,player.ship.position,15000);
		delete this.revenge;
	}
}
this.isEnemy = function(entity){return(entity.isShip && entity.isValid && (entity.isPirate || entity.isPolice || entity.isTrader) && entity.target && entity.target==player.ship && entity.missiles.length);}
this.alertConditionChanged = function(to)
{
	if(to===3 && this.red>2){
		var a = system.filteredEntities(this,this.isEnemy,player.ship,25600);
		if(!a || !a.length) return;
		var b = a[Math.floor(a.length*Math.random())];
		if(Math.random()>0.8-(Math.log(this.red)*0.1)){
			b.fireMissile();
			b.awardEquipment('EQ_VECTOR_FUNA_MISSILE');
		}
	}
}
this.setSound = function(newSound)
{
	if(!this.audio) return;
	switch(newSound){
		case 1: this.mySound.sound = 'vector_passenger1.ogg'; break;
		case 2: this.mySound.sound = 'vector_passenger2.ogg'; break;
	}
	this.mySound.play();
	this.inf.passengerState = newSound;
	return;
}
this.showScreen = function(mtyp,moffer,advice,status)
{
	var ov = "message";
	if(mtyp===1){
		var Title = "Dark corner of "+player.ship.dockedStation.displayName,Message = 'VECTOR_WELCOME',Pic = 'vector_cargobay'+Math.floor(Math.random()*2)+'.png',ov = "tiled",Music = 'vector_opener.ogg';
		this.slaunch = true;
	} else {
		var Title = player.ship.dockedStation.displayName,Message = 'VECTOR_MESSAGE';
		switch(mtyp){
			case 2: var Pic = 'vector_message'+Math.floor(Math.random()*2)+'.png',Music = 'vector_message.ogg',Message = 'VECTOR_REVENGE'; break;
			case 3: var Pic = 'vector_thanks'+Math.floor(Math.random()*2)+'.png',Music = 'vector_gift.ogg'; break;
			case 4: var Pic = 'vector_official'+Math.floor(Math.random()*2)+'.png',Music = 'vector_gift.ogg'; break;
			case 5: var Pic = 'vector_official'+Math.floor(Math.random()*2)+'.png',ov="caught",Music = 'vector_caught.ogg'; break;
			case 6: var Pic = 'vector_thanks'+Math.floor(Math.random()*2)+'.png',Music = 'vector_gift.ogg',Message = 'VECTOR_PRESENT'; break;
			case 7: var Pic = 'vector_inofficial'+Math.floor(Math.random()*2)+'.png',Music = 'vector_gift.ogg'; break;}
		moffer = null;}
	if(!this.audio) Music = null;
	Message = expandMissionText(Message);
	if(mtyp==1){
		if(this.inf.expFactor>1) Message += " \f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\fexp: "+this.inf.expFactor+"\n";
		else Message += " \n------------------------------------------------------------\n";
	}
	ov = "vector_ov"+ov+".png";
	if(moffer) mission.runScreen({title:Title,message:Message,background:Pic,overlay:ov,choicesKey:moffer,music:Music},this.choiceEvaluation);
	else mission.runScreen({title:Title,message:Message,background:Pic,overlay:ov,music:Music});
	if(advice){
		mission.addMessageText(this.mc.advice);
		this.mc.advice = '';
	}
	if(status){
		var i = status;
		while(i--){mission.addMessageText("");}
		mission.addMessageText("Name: \r\r\r\r\r"+expandDescription("[commander_name]")+"\r\r\r\r\rGC-ID: #"+player.ship.entityPersonality);
		mission.addMessageText("Account:\r\r\r\r"+player.credits.toFixed(1)+"\nStatus:\r\r\r\r\r"+player.legalStatus+"\nClassification: \r"+player.rank+"\nRating:\r\r\r\r\r"+player.score);
		if(this.inf.expFactor<=1) b = "none";
		else {
			var a = Math.floor(this.inf.expFactor*0.33),b = '';
			while(a--){b += '\b';}
		}
		mission.addMessageText("\nExperience: "+b);
	}
	return;
}
this.shipWillEnterWitchspace = function()
{
	this.cleanAdvice();
}
this.shipWillExitWitchspace = function()
{
	this.checkSun();
	this.checkPodsTime();
	this.allowS = false;
	this.allowI = false;
	if(this.ISSOrNova) return;
	++this.addChance;
	this.addChance &= 7;
	if((clock.days&31)===this.addChance && missionVariables.vector_arn && missionVariables.vector_arn==='UNLIMITED') system.addShipsToRoute('vector_arn',1,0.1,'wp');
	if(!this.extraA || this.red>6) return;
	if(this.logging) log(this.name,this.name+": Exp:"+this.inf.expFactor+" Ships:"+system.countShipsWithRole('vector')+" Gov:"+system.government);
	if((system.ID&this.addChance)===this.addChance && system.government>3 && player.score>200) system.addShipsToRoute('vector_richman',1,(this.inf.expFactor*0.01),'wp');
}
this.equipmentDamaged = function(equipmentKey)
{
	if(equipmentKey==='EQ_VECTOR_SCOOPS') player.ship.removeEquipment('EQ_VECTOR_SCOOPS');
}
this.checkSun = function()
{
	if(system.isInterstellarSpace || system.sun.isGoingNova || system.sun.hasGoneNova) this.ISSOrNova = true;
	else this.ISSOrNova = false;
	return;
}
this.checkPodsTime = function()
{
	if(player.score>249) return;
	if((clock.days&7)===7 && this.extraA) missionVariables.vector_limiter = Math.max(1,this.red);
	else missionVariables.vector_limiter = 0;
	if(this.logging) log(this.name,this.name+': Pods:'+missionVariables.vector_limiter+' Day:'+(clock.days&7));
	return;
}
this.shipDied = function()
{
	this.cleanAdvice();
	this.mySound.stop();
}
this.cleanAdvice = function()
{
	if(this.adviceTimer){
		this.adviceTimer.stop();
		delete this.adviceTimer;
	}
	return;
}
/* Notification from OXPConfig2.x -> change subscripts */
this.oxpcNotifyOnChange = function()
{
	if(worldScripts.vector_missionArn.init) worldScripts.vector_missionArn.init = true;
	return;
}
/* OXPConfig audio = sound and music, extraA = adding additional vector, extraB = advanced status display */
this.oxpcSettings = {
	Info: {Name:"vector",Display:"Vector",InfoB:"Climb to the top of the 'business' or be the good guy."},
	Bool0: {Name:"logging",Def:false,Desc:"Logging functions."},
	Bool1: {Name:"audio",Def:true,Desc:"Sound and music."},
	Bool2: {Name:"extraA",Def:false,Desc:"Additional Vectors."},
	Bool3: {Name:"extraB",Def:true,Desc:"Advanced Status Display."}
};
