"use strict";
this.name = "vector_areidis";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Areidis-Station handling";
this.version = "1.7.1";

this.startUp = function()
{
	delete this.startUp;
	if(!worldScripts.Cabal_Common_Functions || typeof(worldScripts.Cabal_Common_Functions.Cabal_Common)==='undefined'){this.killSelf(" -> Cabal_Common_Library is missing."); return;}
	this.helper = new worldScripts.Cabal_Common_Functions.Cabal_Common();
	if(this.helper.internalVersion<14){this.killSelf(" -> Cabal_Common_Functions is too old."); return;}
	delete this.killSelf;
	if(worldScripts.vector_pad.startUp) worldScripts.vector_pad.startUp();
	this.infos = worldScripts.vector_pad.padInfos.areidis;
}
this.killSelf = function(desc)
{
	if(desc!==1){player.consoleMessage(this.name+" - Check your Latest.log.",10); log(this.name,this.name+" - Shutting down."+desc);}
	for(prop in this){delete this[prop];}
	this.deactivated = true;
	return;
}
this.missionScreenOpportunity = function()
{
// Codes 1 = codecard, 2 who, 4 where, 8 password, 16 message, 32 decrypted, 64 visited, 128 disabled, 256 destroyed, 512 actor found, 1024 actor done
	if(!player.ship.docked) return;
	var st = player.ship.dockedStation;
	if(!st.hasRole('areidis')) return;
	this.infos = worldScripts.vector_pad.padInfos.areidis;
	if(this.walkDone){
		if(this.ar && this.ar.cubeDone) this.cubesCB(true);
		else this.cubesCB(false);
	} else {
		this.ar = new Object({s:null,blocked:true,cubeDone:false});
		this.ar.swSound = new SoundSource;
		this.ar.swSound.loop = false;
		if(oolite.gameSettings.shaderEffectsLevel=='SHADERS_OFF' || oolite.gameSettings.shaderEffectsLevel=='SHADERS_NOT_SUPPORTED') this.ar.sLevel = false;
		else this.ar.sLevel = true;
		// Change blocked...
		this.ar.blocked = st.script.autoDefense;
		// Set current #
		this.ar.areidis = this.infos.locations.indexOf(system.ID);
		var obj = {
			role:"vector_areidiswalk_corridor",
			absolutePos:[0.1,0.1,250],
			ori:[1,0,0,0],
			briefing:[
				[1,"repos",[0,2,[0,0,218]]],
				[2,"repos",[0,3,[0,0,218]]],
				[3,"prop",[0,-1,"fuel",0.1,4,0,4]],
				[4,"prop",[0,2,"fuel",0.1,4,0,4]],
				[16,"walk",[0,-1,6,10,0.15,2,0,0],"Spooky. Looks like a major malfunction... or sabotage.","vector_stationwalk.ogg",3],
				[40,null,null,null,"vector_stationdoors1.ogg"],
				[41,"prop",[0,-1,"lightsActive",true,0,0,0]],
				[42,"continue",["checkpoints",1]],
				[45,"stopVelo",[0,-1]],
				[46,null,null,null,"vector_stationdoors2.ogg"],
				[47,"mVelo",[0,0,12,0,-5.7,0,0,2,4]],
				[48,"mVelo",[0,1,12,0,5.7,0,0,2,4]],
				[90,"prop",[0,-1,"lightsActive",false,0,0,0]],
				[97,"walk",[0,-1,16,26.7,0.15,0.75,0,0],"Hmm. Nobody's here.","vector_stationwalk.ogg",8],
				[121,null,null,"What happened? There must have been a explosion."],
				[159,"prop",[0,2,"fuel",-0.05,4,4,4]],
				[160,"stopSound"],
				[161,"bind",[0,2,8,3,0]],
				[162,"rot",[0,3,2.5,0,0.015,0,0,1,1]],
				[163,"rot",[0,2,2.5,0,0.018,0,0,1,1]],
				[164,"zoom",[0,3,1.5,0.995,0,1,0.5]],
				[165,null,null,"I just got here. This terminal seems to be active...","vector_walkdone.ogg"],
				[196,"zoom",[0,3,1,0.975,0,1,0]],
				[200,"kill","VECTOR_AREIDIS_SKIP"],
				[201,0]
			],
			title:player.ship.dockedStation.displayName,
			background:"vector_areidiswalk.png",
			music:"vector_areidis.ogg",
			callback:this.name,
			callbackf:"choiceEval"
		};
		if(this.ar.blocked || !missionVariables.vector_arn || missionVariables.vector_arn!=='UNLIMITED') obj.callbackc = 'VECTOR_AREIDIS';
		else obj.callbackc = 'VECTOR_AREIDISB';
		// Set visited
		worldScripts.vector_pad.padInfos.areidis.codes[this.currentAreidis] |= 64;
		// Set where
		if(worldScripts.vector_pad.padInfos.areidis.display.where[this.currentAreidis]==="Unknown") worldScripts.vector_pad.addToLogbook("DAA "+system.name,"DAB");
		worldScripts.vector_pad.padInfos.areidis.display.where[this.currentAreidis] = system.name;
		worldScripts.Cabal_Common_Briefing.startBriefing(obj);
	}
	return;
}
this.checkpoints = function(n)
{
	if(!missionVariables.vector_arn || missionVariables.vector_arn!=='UNLIMITED') return(false);
	if(n===1){
		if(!this.ar.blocked) return(true);
		else mission.addMessageText("Hmm. The doors seem to be blocked. I should return later.");
	}
	return(false);
}
this.callCubes = function()
{
	if((worldScripts.vector_pad.padInfos.areidis.codes[this.currentAreidis]&1)){
		var hint = worldScripts.vector_pad.decrypt(this.infos.code,this.infos.hints[this.currentAreidis].hint,this.infos.hints[this.currentAreidis].fib);
		var obj = new Object({who:this.name,code:this.infos.cubic[this.currentAreidis],ovl:this.infos.materials[this.currentAreidis],noovl:hint,image:'vector_areidiswalk.png'});
	} else var obj = new Object({who:this.name,code:this.infos.cubic[this.currentAreidis],ovl:0,noovl:0,image:'vector_areidiswalk.png'});
	worldScripts.vector_cubes.startCubes(obj);
	return;
}
this.choiceEval = function(choice){worldScripts.vector_areidis.delayChoice(choice); return;}
this.delayChoice = function(choice)
{
	switch(choice){
		case 'VECTOR_AREIDIS_EXIT':
			this.ar.swSound.stop();
			player.ship.launch();
			break;
		case 'VECTOR_AREIDIS_SKIP':
			this.ar.swSound.stop();
			this.callCubes();
			break;
		case 'VECTOR_AREIDIS_TERMINAL':
			this.callCubes();
			break;
		case 'VECTOR_AREIDIS_PAD':
			worldScripts.vector_pad.startPAD("codes");
			break;
	}
	return;
}
// Callback
this.cubesCB = function(state)
{
	if(state){
		mission.runScreen({title:player.ship.dockedStation.displayName,choicesKey:'VECTOR_AREIDISD',background:'vector_areidiswalk.png',music:'vector_areidis.ogg'},this.choiceEval);
		var a = worldScripts.vector_pad.padInfos.areidis.messages[this.currentAreidis];
		var b = this.helper.strScreenSubString(expandMissionText(a),70);
		mission.addMessageText("Messages to 'contacts':\n");
		mission.addMessageText(b);
		this.showSound(0,'vector_areidismessage.ogg');
		this.ar.cubeDone = true;
		this.walkDone = true;
		worldScripts.vector_pad.padInfos.areidis.codes[this.currentAreidis] |= 16;
	} else mission.runScreen({title:player.ship.dockedStation.displayName,choicesKey:'VECTOR_AREIDISC',background:'vector_areidiswalk.png',music:'vector_areidis.ogg'},this.choiceEval);
	return;
}
this.showSound = function(loop,sound)
{
	if(loop) this.ar.swSound.loop = true;
	else this.ar.swSound.loop = false;
	this.ar.swSound.sound = sound;
	this.ar.swSound.play();
	return;
}
this.shipWillLaunchFromStation = function()
{
	this.walkDone = false;
	if(this.ar) delete this.ar;
}
