"use strict";
this.name = "vector_areidisStation";
this.author = "Svengali";
this.copyright = "CC-by-nd-sa-3.0";
this.description = "Areidis station";
this.version = "1.7.1";

this.shipSpawned = function()
{
	let c = ['Alpha','Beta','Gamma','Delta','Epsilon'];
	this.areidisIndex = c.indexOf(this.ship.name.substr(8,30));
	this.ship.subEntities[2].fuel = this.areidisIndex/10;
	this.prop = -0.35;
	this.autoDefense = true;
	this.emp = true;
	this.channel = false;
	this.ship.suppressArrivalReports = true;
	if(this.areidisIndex>2) this.areidisComm = {display:"Areidis",who:this.ship,ent:true,pID:this.ship.entityPersonality,callback:"commCall",react:[{display:"Send code"},{display:"Back"}]};
	var buoy = 0;
	if(player.ship.equipmentStatus('EQ_VECTOR_AREIDIS_SCANNER')==='EQUIPMENT_OK') buoy=2;
	else if(!this.areidisIndex) buoy=1;
	if(!buoy) return;
	if(!system.countShipsWithRole('vector_areidisBuoy')){
		if(buoy===1) system.addShips('vector_areidisBuoyA',1,this.ship.position.add([5000,5000,5000]));
		else system.addShips('vector_areidisBuoyB',1,this.ship.position.add([5000,5000,5000]));
	}
	if(buoy===2) player.commsMessage("Areidis station detetcted.");
	else player.commsMessage("Unknown architecture detetcted.");
}
this.shipTakingDamage = function(amount,whom,type)
{
	if(!player.ship.isValid) return;
	if(whom){
		if(whom.isPlayer){
			if(this.ship.subEntities.length<(this.ship.subEntityCapacity-this.areidisIndex)){
				this.autoDefense = false;
				this.ship.lightsActive = false;
				if(!this.ship.subEntities[3].fuel && !this.animTimer){
					this.prop *= -1.0;
					this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
				}
				if(this.ship.target) this.ship.target = null;
				return;
			}
		}
	}
	this.autoDefense = true;
	this.ship.lightsActive = true;
	if(this.ship.subEntities[3].fuel===7 && !this.animTimer){
		this.prop *= -1.0;
		this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
	}
}
this.shipBeingAttackedByCloaked = function()
{
	if(!player.ship.isValid) return;
	if((this.areidisIndex&1) && this.emp){
		this.ship.spawnOne("EQ_VECTOR_EMP_MINE");
		this.emp = false;
	}
}
this.alertConditionChanged = this.getTarget = function(nC)
{
	if(!player.ship.isValid) return;
	if(player.ship.docked && player.ship.dockedStation==this.ship){
		if(nC===3){
			var aSound = new SoundSource;
			aSound.sound = 'vector_stationalert.ogg';
			aSound.play();
			this.autoDefense = true;
			this.ship.lightsActive = true;
			if(!this.ship.subEntities[3].fuel && !this.animTimer){
				this.prop *= -1.0;
				this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
			}
			return;
		}
	}
	var entList = this.findTheBadOnes();
	if(entList.length>0){
		var enemy = entList[0];
		if(enemy.position.distanceTo(this.ship.position)>22000) enemy = entList[Math.floor(Math.random()*entList.length)];
		if(enemy.isPlayer){
			if(!this.autoDefense) return;
			if(!this.channel){
				worldScripts.Cabal_Common_Comms.addToComm(this.myComm);
				this.channel = true;
			}
		}
		if(enemy.position.distanceTo(this.ship.position)<22000){
			if(this.autoDefense){
				this.ship.target = enemy;
				this.ship.reactToAIMessage('TARGET_FOUND');
				this.ship.lightsActive = true;
				if(this.ship.subEntities[3].fuel===7 && !this.animTimer){
					this.prop *= -1.0;
					this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
				}
				return;
			}
		}
	}
	if(this.ship.alertCondition>2) this.ship.reactToAIMessage('COOL_DOWN');
	return;
}
this.isBad = function(entity)
{
	return(entity.isShip && !entity.isBeacon && !entity.isCargo && (!entity.isWeapon || (entity.owner && !entity.owner.hasRole('areidis'))) && entity.status=='STATUS_IN_FLIGHT' && !entity.isCloaked);
}
this.findTheBadOnes = function()
{
	return system.filteredEntities(this,this.isBad,this.ship,25600);
}
this.shipDied = function()
{
	if(!player.ship.isValid) return;
	if(this.animTimer) this.animTimer.stop();
	if(worldScripts.vector_areidis.swSound) worldScripts.vector_areidis.swSound.stop();
	if(system.countShipsWithRole('vector_areidisBuoy')) system.shipsWithRole('vector_areidisBuoy')[0].explode();
}
this.doAnimTimer = function()
{
	this.ship.subEntities[3].fuel += this.prop;
	this.ship.fuel -= this.prop*1.3;
	if(!this.ship.subEntities[3].fuel || this.ship.subEntities[3].fuel===7){
		this.animTimer.stop();
		delete this.animTimer;
	}
}
this.commCall = function(action)
{
	switch(action){
		case 0:
			if(!this.ship.subEntities[3].fuel && !this.animTimer){
				this.autoDefense = false;
				this.ship.lightsActive = false;
				this.prop *= -1.0;
				this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
				if(this.ship.target) this.ship.target = null;
				this.ship.commsMessage("Disabling selfdefense mode.");
			}
			if(this.ship.subEntities[3].fuel===7 && !this.animTimer){
				this.autoDefense = true;
				this.ship.lightsActive = true;
				this.prop *= -1.0;
				this.animTimer = new Timer(this,this.doAnimTimer,0,0.25);
				this.ship.commsMessage("Enabling selfdefense mode.");
			}
			break;
	}
	return;
}
