"use strict";
this.name = "vector_ovc";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Overlays Characters";
this.version = "1.7.1";

this.shipSpawned = function()
{
	this.getSlot();
	this.cycle = parseInt(this.ship.scriptInfo.vector_ovcycle);
	this.getPos();
	if(!this.reposTimer) this.reposTimer = new Timer(this,this.repositionIt,0,3.81);
	delete this.shipSpawned;
}
this.repositionIt = function()
{
	if(!player.ship.isValid || player.ship.docked){this.getRid(1,1); return;}
	if(!this.cycle){
		this.ship.position = this.moveOutPos.add([1000+this.ship.fuel,0,0]);
		this.getRid();
		return;
	}
	let a = player.ship.vectorForward.multiply(400.0*(this.ship.fuel+1)),b = player.ship.vectorUp.multiply(200.0*(this.ship.fuel+1));
	this.ship.position = player.ship.position.subtract(a).subtract(b);
	this.ship.orientation = player.ship.orientation;
	if(this.cycle>0) this.cycle--;
	if(this.displayMessage){
		var mySound = new SoundSource;
		if(this.displaySound) mySound.sound = this.displaySound;
		else mySound.sound = '[vector_peep]';
		mySound.play();
		if(typeof(this.displayMessage)==='string') this.ship.commsMessage(this.displayMessage);
		else this.displayMessage.ent.commsMessage(this.displayMessage.message);
		delete this.displayMessage;
	}
	return;
}
this.getRid = function(way,all)
{
	if(this.reposTimer) this.reposTimer.stop();
	missionVariables.vector_cslot &= 0xffff-Math.pow(2,this.ship.fuel);
	if(way) this.ship.remove(true);
	if(all) missionVariables.vector_cslot = null;
	else if(missionVariables.vector_cslot==="0") missionVariables.vector_cslot = null;
	return;
}
this.shipRemoved = function(suppressDeathEvent)
{
	delete this.shipDied;
	return;
}
this.shipDied = this.shipWillEnterWitchspace = function()
{
	this.getRid();
	return;
}
this.speakUp = function(slot,message,audio)
{
	if(!slot && (!this.reposTimer || !this.reposTimer.isRunning)) this.getSlot();
	this.cycle = parseInt(this.ship.scriptInfo.vector_ovcycle);
	if(!this.moveOutPos) this.getPos();
	if(!this.reposTimer) this.reposTimer = new Timer(this,this.repositionIt,0,3.81);
	else {
		if(!this.reposTimer.isRunning){
			this.reposTimer.nextTime = clock.absoluteSeconds+1;
			this.reposTimer.start();
		}
	}
	if(message) this.displayMessage = message;
	if(audio) this.displaySound = audio;
	delete this.shipSpawned;
	return;
}
this.addSilent = function()
{
	delete this.shipSpawned;
	this.cycle = 0;
	this.getPos();
	if(this.reposTimer) this.reposTimer.stop();
	return;
}
this.getSlot = function()
{
	if(missionVariables.vector_cslot===null) missionVariables.vector_cslot = 0;
	var a = parseInt(missionVariables.vector_cslot);
	for(var i=0;i<8;i++){
		var o = Math.pow(2,i);
		if(!(a&o)){
			this.ship.fuel = i;
			missionVariables.vector_cslot |= o;
			break;
		}
	}
	return;
}
this.getPos = function()
{
	if(system.isInterstellarSpace || !system.sun || system.sun.isGoingNova || system.sun.hasGoneNova) this.moveOutPos = new Vector3D([100000,66640,0]);
	else this.moveOutPos = system.sun.position;
	this.moveOutPos = this.moveOutPos.multiply(20);
	return;
}