"use strict";
this.name = "vector_richman";
this.author = "Svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Richman's action";
this.version = "1.7.1";

this.shipSpawned = function()
{
	if(worldScripts.vector_pad.deactivated) this.noAct = true;
	this.cargoAmount = Math.max(1,Math.ceil(Math.random()*8));
	this.hitsCounter = 0;
	this.entryNumber = (Math.random()*this.ship.entityPersonality)&3;
	if(Math.random()>0.9 && missionVariables.vector_arn) this.podToEject = ['vector_cpodD','vector_cpodB','vector_cpodC','vector_cpodD'];
	else this.podToEject = ['vector_cpodA','vector_cpodB','vector_cpodC','vector_cpodD'];
	if(this.ship.primaryRole==='vector_richman') this.ship.primaryRole = 'trader';
	if(this.ship.scriptInfo.vector_name!==null) this.vector_plea = "[vector_plea"+this.ship.scriptInfo.vector_name+"]";
	this.ship.displayName = "Vector"+this.ship.scriptInfo.vector_epodName;
	if(system.sun.isGoingNova || system.sun.isGoneNova || system.countShipsWithRole('vector')>1){
		this.ship.switchAI('vector_leaveAI.plist');
		return;
	} else {
		if(!system.mainStation || system.mainStation.position.distanceTo(this.ship)<35000 || this.entryNumber===1) this.ship.switchAI('vector_sunskimAI.plist');
		else {
			this.ship.switchAI('vector_traderAI.plist');
			this.ship.fuel = 2;
			if(Math.random()<0.4 && system.countShipsWithRole('repaired-buoy-station')) this.goToStat = system.shipsWithPrimaryRole('repaired-buoy-station')[0];
			else this.goToStat = system.mainStation;
		}
	}
	this.init = true;
}
this.shipBeingAttacked = function(whom)
{
	if(!this.init) this.shipSpawned();
	if(this.cargoAmount) this.vectorDropCargo(whom);
	this.vectorDisplayName();
}
this.shipAttackedWithMissile = function(missile,whom)
{
	if(!this.init) this.shipSpawned();
	this.ship.target = missile;
	if(this.cargoAmount) this.vectorDropCargo(whom);
	this.vectorDisplayName();
}
this.shipTargetDestroyed = function()
{
	this.ship.displayName = "Vector(Pleased "+this.ship.scriptInfo.vector_name+")";
}
this.vectorDisplayName = function()
{
	if(this.ship.energy===this.ship.maxEnergy) this.ship.displayName = "Vector("+this.ship.scriptInfo.vector_name+")";
	if(this.ship.energy>430 && this.ship.energy<this.ship.maxEnergy) this.ship.displayName = "Vector(Angry "+this.ship.scriptInfo.vector_name+")";
	if(this.ship.energy<431 && this.ship.energy>179) this.ship.displayName = "Vector(Shaked "+this.ship.scriptInfo.vector_name+")";
	if(this.ship.energy<180) this.ship.displayName = "Vector(Scared "+this.ship.scriptInfo.vector_name+")";
	this.entryNumber =(Math.random()*this.ship.entityPersonality)&3;
}
this.vectorDropCargo = function(whom)
{
	if(this.hitsCounter<5) ++this.hitsCounter;
	else {
		if(!this.noAct) this.ship.ejectSpecificItem(this.podToEject[this.entryNumber]);
		this.cargoAmount -= 1;
		this.hitsCounter = 0;
		if(whom.isPlayer) player.commsMessage(expandDescription(this.vector_plea));
	}
	this.vectorDisplayName();
}
this.shipHitByECM = function(ecmPulsesRemaining)
{
	if(!this.ship.target && ecmPulsesRemaining===2 &&(this.ship.AIState==='HEAD_FOR' || this.ship.AIState==='GO_TO_WAYPOINT') && this.ship.escorts) this.ship.AIState = 'SCAN_AREA';
}
this.checkTarget = function()
{
	var attackbreak = false;
	if(this.ship.escorts){
		var i = this.ship.escorts.length;
		while(--i){
			if(this.ship.escorts[i]==this.ship.target){
				attackbreak = true;
				this.ship.target = null;
				this.ship.AIState = 'HEAD_FOR';
			}
		}
		if(!attackbreak) this.ship.AIState = 'ATTACK_SHIP';
	} else {
		if(this.ship.energy<250) this.ship.AIState = 'FLEE';
		else this.ship.AIState = 'ATTACK_SHIP';
	}
}
this.checkDistanceToSun = function()
{
	if(this.ship.AI==='vector_sunskimAI.plist' && system.sun.position.distanceTo(this.ship)<system.sun.radius*2.5){
		this.ship.fuel += 3.0;
		this.ship.reactToAIMessage('SPEED_UP');
	}
}
this.addFuel = function()
{
	this.ship.fuel += 3.0;
}
this.getStation = function()
{
	if(this.goToStat===system.mainStation || Math.random()<0.4){
		if(!system.mainStation || !system.mainStation.isValid){
			this.ship.switchAI('vector_leaveAI.plist');
			return;
		} else {
			this.ship.target = system.mainStation;
			this.ship.AIState = 'GO_TO_STATIONA';
		}
	} else {
		this.ship.target = this.goToStat;
		this.ship.AIState = 'GO_TO_STATIONB';
	}
	return;
}
