"use strict";
this.name = "vector_specialiststation";
this.author = "Svengali";
this.copyright = "CC-by-nd-sa-3.0";
this.description = "Station";
this.version = "1.7.1";

this.shipSpawned = function()
{
	this.fcbhelper = new worldScripts.Cabal_Common_Briefing.Cabal_Common_ScreenFCB();
	this.anim = false;
	this.dd = this.ship.dockedDefenders;
	this.ddscheduled = 0;
	this.fun = [
		[{display:"Send identification"},{display:"Back"}],
		[{display:"Send identification"},{display:"Readout status"},{display:"Back"}]
	];
	this.commChannel = {display:"Specialist",who:this.ship,ent:true,pID:this.ship.entityPersonality,callback:"commCall",react:this.fun[0]};
	this.ov = new worldScripts.vector_news.VectorOV();
	this.granted = false;
	if(worldScripts.vector_news.secondaryInfos.specialist.state>3) this.ship.spawnOne("vector_specialistmark");
}
this.doAnim = function(n)
{
	if(this.anim) return;
	this.anim = true;
	if(this.ship.subEntities[3].energy>0) this.fcbhelper.fcbSetProp(this.ship,3,"energy",-0.01*n,19/n,1,0);
	else this.fcbhelper.fcbSetProp(this.ship,3,"energy",0.01*n,19/n,1,0);
	this.animTimer = new Timer(this,this.doAnimTimer,20/n,0);
}
this.doAnimTimer = function()
{
	this.shipDied();
	if(this.granted && this.ship.subEntities[3].energy===0) this.ship.commsMessage("Laser disabled.");
	this.anim = false;
}
this.shipDied = this.shipRemoved = function()
{
	this.fcbhelper.fcbRemoveAll();
	if(this.animTimer) this.animTimer.stop();
	delete this.animTimer;
	if(this.closeDD){
		this.closeDD.stop();
		delete this.closeDD;
	}
	if(this.closeup){
		this.closeup.stop();
		delete this.closeup;
	}
	return;
}
this.commCall = function(action)
{
	if(this.ship.position.distanceTo(player.ship.position)>25000 || this.psa) return;
	switch(action){
		case 0:
			this.ship.commsMessage("Received Identification. We'll disable the laser now.");
			if(this.ship.subEntities[3].energy>0) this.doAnim(1);
			if(!this.granted){
				this.granted = true;
				var newSet = this.fun[1];
				worldScripts.Cabal_Common_Comms.changeChoicesComm(this.commChannel.pID,newSet);
				this.commChannel.react = newSet;
			}
			break;
		case 1:
			if(this.animTimer) this.ship.commsMessage("Laser status is changing.");
			else {
				if(this.ship.subEntities[3].energy>0) this.ship.commsMessage("Laser enabled.");
				else this.ship.commsMessage("Laser disabled.");
			}
	}
	return;
}
this.shipBeingAttacked = function(whom)
{
	if(!whom){
		this.ship.spawnOne("EQ_VECTOR_EMP_MINE");
		return;
	}
	if(!this.ddscheduled && this.ship.dockedDefenders && this.ship.AIState==="DEFENSE_MODE") this.getThemOut();
	if(player.ship.isValid && whom.isPlayer){
		if(this.chan){
			worldScripts.Cabal_Common_Comms.removeFromComm(this.commChannel);
			delete this.chan;
		}
		this.psa = true;
		this.granted = false;
	}
	this.ship.fireMissile("EQ_VECTOR_FUNC_MISSILE");
}
this.getThemOut = function()
{
	let n = this.ship.dockedDefenders;
	if(n){
		while(n--){
			this.ship.launchDefenseShip();
			this.ddscheduled++;
		}
		if(!this.anim && this.ship.subEntities[3].energy>0) this.doAnim(10);
	}
	return;
}
this.shipTargetCloaked = function()
{
	if(!this.anim && this.ship.subEntities[3].energy===0) this.doAnim(10);
	this.ship.spawnOne("EQ_VECTOR_EMP_MINE");
}
this.checkDock = function()
{
	if(!player.ship.isValid) return;
	if(!this.psa && !this.chan){
		if(this.ship.position.distanceTo(player.ship.position)<25000){
			if(player.ship.isCloaked){
				this.ship.commsMessage("Unknown vessel. Decloak to communicate.");
			} else {
				worldScripts.Cabal_Common_Comms.addToComm(this.commChannel);
				this.ov.addOv(1,'07',null,null,1);
				this.ship.commsMessage("Unknown vessel. Identify! We have established a secure channel.");
				this.chan = true;
			}
		}
	}
	if(!this.closeup) this.closeup = new Timer(this,this.doCloseup,0,2);
}
this.stationLaunchedShip = function(whom)
{
	if(whom){
		if(whom.isPlayer){
			this.shipDied();
			this.anim = false;
			this.ship.subEntities[3].energy = 9;
		} else {
			if(this.ddscheduled) this.ddscheduled--;
			this.dd = this.ship.dockedDefenders;
			if(!this.closeDD) this.closeDD = new Timer(this,this.doCloseDD,0,2);
		}
	}
}
this.doCloseDD = function()
{
	if(this.ddscheduled) return;
	if(!this.anim && this.ship.subEntities[3].energy===0){
		this.doAnim(10);
		this.closeDD.stop();
		delete this.closeDD;
		this.dd = this.ship.dockedDefenders;
	}
}
this.doCloseup = function()
{
	function isDocker(entity){return entity.isValid && entity.isShip && !entity.isWeapon && !entity.isCargo}
	var a = system.filteredEntities(this,isDocker,this.ship,3500);
	if(a.length){
		for(let i=0;i<a.length;i++){
			if(a[i].owner && a[i].owner===this.ship){
				let d = a[i].position.distanceTo(this.ship.position);
				if(a[i].position.distanceTo(this.ship.position)<2600 && !this.anim && this.ship.subEntities[3].energy>0) this.doAnim(10);
			}
		}
	}
}
this.otherShipDocked = function(whom)
{
	if(whom.owner===this.ship){
		this.dd = this.ship.dockedDefenders;
		if(this.closeup){
			this.closeup.stop();
			delete this.closeup;
		}
		if(this.ddscheduled) this.ddscheduled = 0;
	}
	if(!this.anim && this.ship.subEntities[3].energy===0) this.doAnim(10);
}
