"use strict";
this.name = "vector_updater";
this.author = "svengali";
this.copyright = "CC-by-nc-sa-3.0";
this.description = "Updater for older versions";
this.version = "1.7.1";

this.startUp = function()
{
	delete this.startUp;
	if(worldScripts.vector_pad.startUp) worldScripts.vector_pad.startUp();
	if(worldScripts.vector_pad.deactivated){this.killSelf(); return;}
	if(player.ship.status === "STATUS_START_GAME"){this.killSelf(); return;}
	if(missionVariables.vector_version){this.killSelf(); return;}
	var excl = ["vector_cpod","vector_cpods","vector_epod","vector_epods","vector_expFactor","vector_passengerState","vector_limiter","vector_generic"];
	var action = false;
	for(let prop in missionVariables){if((prop.substr(0,6)==='vector' || prop.substr(0,9)==='localhero') && excl.indexOf(prop)===-1){action = true; break;}}
	if(!action){this.killSelf(); return;}
}
this.killSelf = function()
{
	missionVariables.vector_version = "1_7";
	for(prop in this){if(prop!=='name' && prop!=='version') delete this[prop];}
	this.deactivated = true;
	return;
}
this.missionScreenOpportunity = function()
{
	if(!player.ship.docked) return;
	mission.runScreen({messageKey:'VECTOR_UPDATE',choicesKey:'VECTOR_UPDATEYN',background:'vector_official1.png',music:'vector_transmission.ogg'},this.choiceEval);
	return;
}
this.choiceEval = function(choice)
{
	if(!choice){log(this.name,"Booh. Not updated!"); return;}
	switch(choice){
		case 'VECTOR_UPDATEJ':
			var gal,destNum,destIDs,destName;
			// Clear destinations from versions<1.4.3
			if(missionVariables.vector){
				if((missionVariables.vector[0]==='V' || missionVariables.vector[0]==='R')){
					if(missionVariables.vector_visits && galaxyNumber===parseInt(missionVariables.vector_visits[missionVariables.vector_visits.length-1])){
						gal = parseInt(missionVariables.vector_visits[missionVariables.vector_visits.length-1])
						destNum = parseInt(missionVariables.vector[5]);
						destIDs = missionVariables.vector_visits.split(" ");
						destName = System.systemNameForID(destIDs[destNum-1]);
						mission.unmarkSystem(destIDs[destNum-1]);
						mission.setInstructionsKey(null,'vector');
					} else mission.setInstructionsKey(null,'vector');
				}
			}
			// Clear destinations versions>1.4.2
			if(missionVariables.vector_arn){
				if((missionVariables.vector_arn[0]==='V' || missionVariables.vector_arn[0]==='R')){
					if(missionVariables.vector_arnvisits && galaxyNumber===parseInt(missionVariables.vector_arnvisits[missionVariables.vector_arnvisits.length-1])){
						gal = parseInt(missionVariables.vector_arnvisits[missionVariables.vector_arnvisits.length-1]);
						destNum = parseInt(missionVariables.vector_arn[5]);
						destIDs = missionVariables.vector_arnvisits.split(" ");
						destName = System.systemNameForID(destIDs[destNum-1]);
						mission.unmarkSystem(destIDs[destNum-1]);
						mission.setInstructionsKey(null,'vector_missionArn');
					} else mission.setInstructionsKey(null,'vector_missionArn');
				}
			}
			mission.setInstructionsKey(null,'localhero');
			// Clear mVs
			var excl = ["vector_cpod","vector_cpods","vector_epod","vector_epods","vector_expFactor","vector_passengerState","vector_limiter","vector_generic"];
			for(let prop in missionVariables){
				if((prop.substr(0,6)==='vector' || prop.substr(0,9)==='localhero') && excl.indexOf(prop)===-1){
					missionVariables[prop] = null;
				}
			}
			// Get rid of the EQs
			missionVariables.TL_FOR_EQ_VECTOR_SCOOPS = null;
			if(player.ship.equipmentStatus('EQ_VECTOR_SCOOPS')==='EQUIPMENT_OK') player.ship.removeEquipment('EQ_VECTOR_SCOOPS');
			missionVariables.TL_FOR_EQ_VECTOR_PAD = null;
			if(player.ship.equipmentStatus('EQ_VECTOR_PAD')==='EQUIPMENT_OK') player.ship.removeEquipment('EQ_VECTOR_PAD');
			if(player.ship.equipmentStatus('EQ_VECTOR_ARNP')==='EQUIPMENT_OK') player.ship.removeEquipment('EQ_VECTOR_ARNP');
			if(player.ship.equipmentStatus('EQ_VECTOR_ALDRIN')==='EQUIPMENT_OK') player.ship.removeEquipment('EQ_VECTOR_ALDRIN');
			// Byebye
			this.killSelf();
			break;
		case 'VECTOR_UPDATEN':
			this.killSelf();
			break;
		default: log(this.name,"Choice not handled.");
	}
	// Kill mission to avoid problems
	for(let prop in worldScripts.vector_missionArn){if(prop!=='name' && prop!=='version') delete worldScripts.vector_missionArn[prop];}
	for(let prop in worldScripts.vector_news){if(prop!=='name' && prop!=='version') delete worldScripts.vector_news[prop];}
	// Clear log
	worldScripts.vector_pad.clearLogbook();
	return;
}
